#!/bin/bash

. /root/custom/config.txt


myTempFile="${myTempDir}ifstat.tmp"

myDataCounterOK=0
myTempFileToggle="1"
myCounterZFSCheck=999
myCounterZFSCheckInterval=10


debugPrint "[AUTOSHUTDOWN]"
debugPrint "[AUTOSHUTDOWN]"
debugPrint "[AUTOSHUTDOWN] Starte $0"
debugPrint "[AUTOSHUTDOWN]"
debugPrint "[AUTOSHUTDOWN]"

myNumberOfRetries=$((myAutoshutdown_TimeInSec / myAutoshutdown_CheckIntervalInSec))

debugPrint "[AUTOSHUTDOWN] Shutdown-Zeit in Sekunden: $myAutoshutdown_TimeInSec, KBit System Ignore: $myAutoshutdown_BaseNetworkTraffic, Anzahl der Testdurchlaeufe: $myNumberOfRetries"
debugPrint "[AUTOSHUTDOWN] TempFile fuer ifstat-Ausgabe: $myTempFile"
debugPrint "[AUTOSHUTDOWN]"

debugPrint "[AUTOSHUTDOWN] Warte $myAutoshutdown_StartUpDelayInSec Sekunden bis Ausfuehrung...."
/usr/bin/sleep $myAutoshutdown_StartUpDelayInSec
debugPrint "[AUTOSHUTDOWN] OK Wartezeit abgelaufen"
debugPrint "[AUTOSHUTDOWN]"

while :
do

    if [ -z "$myAPI_Key" ]; then
	debugPrint "[AUTOSHUTDOWN] APIKey nicht definiert kein ZFS Check"
    else 
	myCounterZFSCheck=$((myCounterZFSCheck+1))
	if [ $myCounterZFSCheck -gt $myCounterZFSCheckInterval ]; then
            myStatus=$("${myBaseDir}scripte_allgemein/getzfsstatus.sh")
	    if [ "$myStatus" = "OK" ]; then
		debugPrint "[AUTOSHUTDOWN] ZFS ist Ok"
	    else
		debugPrint "[AUTOSHUTDOWN] ZFS FEHLER - Autoshutdown ausgesetzt !"
		/usr/bin/sleep $((myAutoshutdown_CheckIntervalInSec*10))
		myDataCounterOK=0
		continue
	    fi

	    myStatus=$("${myBaseDir}scripte_allgemein/getisscrubbing.sh")
	    if [ "$myStatus" = "~" ]; then
		debugPrint "[AUTOSHUTDOWN] Scrub laeuft nicht - Ok"
	    else
		debugPrint "[AUTOSHUTDOWN] Scrub laeuft gerade - Autoshutdown ausgesetzt !"
    		/usr/bin/sleep $(($myAutoshutdown_CheckIntervalInSec*10))
    		myDataCounterOK=0
		continue
	    fi

	    myCounterZFSCheck=0

    	    if [ "$myAutoshutdown_CheckHDDTemp" = "1" ]; then
        	debugPrint "[AUTOSHUTDOWN] Checke HDD Temperaturen...."
		myHDDTempMax=$("${myBaseDir}scripte_allgemein/gethottesthd.sh")
        	debugPrint "[AUTOSHUTDOWN] Waermste HDD ${myHDDTempMax} Grad Celcius"
		if [ $myHDDTempMax -gt $myAutoshutdown_CriticalHDDTemp ]; then
            	    debugPrint "[AUTOSHUTDOWN] Das ist zuviel (Max zulaessig sind: ${myAutoshutdown_CriticalHDDTemp} Grad Celcius!"
            	    debugPrint "[AUTOSHUTDOWN] Sofortiger Stopp!"
            	    /usr/sbin/shutdown -h now
		else
            	    debugPrint "[AUTOSHUTDOWN] HDDTemp ${myHDDTempMax} ist < als ${myAutoshutdown_CriticalHDDTemp} - Ok"
        	fi
    	    fi
	fi
    fi

    if [ $myDebugEnabled = "1" ]; then
	myToggleTempFile="${myTempFile}.${myTempFileToggle}"
	if [ "$myTempFileToggle" = "0" ]; then
	    myTempFileToggle="1"
	else 
	    myTempFileToggle="0"
	fi
    else 
	myTempFileToggle="$myTempFile"
    fi

    # Sicherstellen dass US Format genutzt wird un kein ,
    LANG=C /usr/bin/ifstat -n -i "$myAutoshutdown_Networkcard" -q $myAutoshutdown_CheckIntervalInSec 1 > "$myToggleTempFile"

    unset myDataIn
    unset myDataOut

    myDataIn=$(/usr/bin/less "$myToggleTempFile" | /usr/bin/grep "\." | /usr/bin/awk '{print $1}')
    myDataOut=$(/usr/bin/less "$myToggleTempFile" | /usr/bin/grep "\." | /usr/bin/awk '{print $2}')

    if [ -z "$myDataIn" ]; then
       debugPrint "[AUTOSHUTDOWN] !ERROR! ifstat Fehler auf Netzwerkkarte ${myAutoshutdown_Networkcard}"
       /usr/bin/sleep $myAutoshutdown_CheckIntervalInSec
       myDataCounterOK=0
       continue
    fi

    #Runde auf ganze Zahlen
    myDataIn=$(echo "${myDataIn}" | /usr/bin/sed 's/\..*//')
    myDataOut=$(echo "${myDataOut}" | /usr/bin/sed 's/\..*//')

    debugPrint "[AUTOSHUTDOWN] Netzwerk IN: ${myDataIn} KBit/s,   OUT: ${myDataOut} KBit/s"

    if [ ${myDataIn} -gt $myAutoshutdown_BaseNetworkTraffic ]; then
	myDataCounterOK=0
	debugPrint "[AUTOSHUTDOWN] Ruecksetzen des Counters, da DataIn zu gross ($myDataIn > $myAutoshutdown_BaseNetworkTraffic)"
    fi

    if [ $myDataOut -gt "$myAutoshutdown_BaseNetworkTraffic" ]; then
	myDataCounterOK=0
	debugPrint "[AUTOSHUTDOWN] Ruecksetzen des Counters da DataOut zu gross ($myDataOut > $myAutoshutdown_BaseNetworkTraffic)"
    fi

   myDataCounterOK=$((myDataCounterOK+1))
   debugPrint "[AUTOSHUTDOWN] $myDataCounterOK von $myNumberOfRetries Durchlaeufen fuers Runterfahren"

   if [ $myDataCounterOK -gt $myNumberOfRetries ]; then
      debugPrint "[AUTOSHUTDOWN] Fahre System herunter...."
      /usr/sbin/shutdown -h now
#      exit 0
   fi

done
